var params = require('./params.js');

var api_web_url = params.api_web_url;
var up_img_url = params.up_img_url;
const gps_url = params.gps_url;
var map_bms_url = params.map_url;
var config = {
	APP_VERSION: '4.1.2024121301',
	APP_VERSION_DESC: '优化小程序',
	QQ_MAP_KEY: 'Q7DBZ-BQH65-MEMIO-Q7LEF-S43Z3-G6B34',
	// 腾讯地图api key
	QINIU_SITE: 'https://qiniu.bms16.com/',
	// 拉取图片地址
	QINIU_UPLOAD_SITE: 'https://up-z2.qiniup.com/',
	// 七牛上传地址
	API_QINIU_UP_IMG_TOKEN: up_img_url + '?r=qiniu/token-v2',
	// 获取上传token
	API_GET_OPEN_ID: api_web_url + '?r=user/get-open-id',
	API_OPENID_LOGIN: api_web_url + '?r=user/slogin', //opendid一键登录
	API_CABINET_INFO: api_web_url + '?r=flk/cabinet/info', 
	API_CAR_DEVICE_LIST: api_web_url + '?r=flk/car/device-list', 
	// 机柜换电
	API_FLK_CABINET_CHANGE_BATTERY: api_web_url +'?r=flk/cabinet/exchange-battery',
	//套餐列表
	API_FLK_EXCHANGE_PACKAGE_PACKAGE_LIST: api_web_url +'?r=flk/exchange-package/package-list',
	//套餐购买
	API_FLK_EXCHANGE_PACKAGE_PAY: api_web_url +'?r=flk/exchange-package/pay',
	
	// 套餐购买订单列表
	API_FLK_EXCHANGE_PACKAGE_ORDER_LIST: api_web_url +'?r=flk/exchange-package/order-list',
	// 车辆共享列表
	API_FLK_CAR_SHARE_LIST: api_web_url +'?r=flk/car/share-list',
	//检查邮箱是否存在
	API_ACCOUNT_CHECK_SHARE_ACCOUNT_EXIST: api_web_url +'?r=flk/account/check-account-exist',
	//添加用车人
	API_FLK_CAR_ADD_SHARE_USER: api_web_url +'?r=flk/car/add-share-user',
	//删除用车人
	API_FLK_CAR_REMOVE_SHARE_USER: api_web_url +'?r=flk/car/remove-share-user',
	
	//修改用车人权限: 
	API_FLK_CAR_EDIT_SHARE_USER: api_web_url +'?r=flk/car/edit-share-user',
	
	//共享用车人详情
	API_FLK_CAR_EDIT_SHARE_INFO: api_web_url +'?r=flk/car/share-info',
	
	//修改用户昵称、头像
	API_USER_MODIFY_USER_INFO: api_web_url +'?r=user/modify-user-info',
	//用户信息,
	API_USER_INFO: api_web_url +'?r=user/info',
	
	//机柜换电状态查询: ,
	API_FLK_CABINET_EXCHANGE_STATUS: api_web_url +'?r=flk/cabinet/exchange-status',
	//附近机柜列表: flk/cabinet/near-list
	API_FLK_CABINET_NEAR_LIST: api_web_url +'?r=flk/cabinet/near-list',
	//忘记密码
	API_FLK_CABINET_RESET_PASSWORD: api_web_url +'?r=flk/account/reset-password',
	
	//取消订单
	API_FLK_ORDER_CANCEL_PAY: api_web_url +'?r=flk/order/cancel-pay',
	//激活车辆(绑定设备): 
	API_CAR_ASSIGNMENT: api_web_url +'?r=flk/car/assignment',
	//门店设置:
	API_FLK_INDEX_SHOP_SETTING: api_web_url +'?r=flk/index/shop-setting',
	//申请还车: :
	API_FLK_CAR_RETURN_CAR: api_web_url +'?r=flk/car/return-car',
	//换电记录:
	API_FLK_CABINET_EXCHANGE_ORDER: api_web_url +'?r=flk/cabinet/exchange-order',
	//续租: 
	API_FLK_ORDER_RENEW: api_web_url +'?r=flk/order/renew',
	
	//车辆仪表盘
	API_FLK_CAR_DASHBOARD: api_web_url +'?r=flk/car/dashboard',
	//购买下单
	API_FLK_ORDER_RESERVE: api_web_url +'?r=flk/order/reserve',
	//获取逾期金额:
	API_FLK_CAR_OVERDUE_MONEY: api_web_url +'?r=flk/car/overdue-money',
	
};
module.exports = config;